--[[
    Database of all minipets and mounts
    $Revision: 77497 $
]]--

--[[
Copyright (c) 2008, LordFarlander
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
]]--

HEADER = "--\[\[\n"..
    "    Database of all minipets and mounts\n"..
    "    $Revision: 77497 $\n"..
    "\]\]--"..
    "\n"..
    "\n"..
    "--\[\[\nCopyright (c) 2008, LordFarlander\n"..
    "All rights reserved.\n"..
    "\n"..
    "Redistribution and use in source and binary forms, with or without\n"..
    "modification, are permitted provided that the following conditions are met:\n"..
    "\n"..
    "    * Redistributions of source code must retain the above copyright notice,\n"..
    "      this list of conditions and the following disclaimer.\n"..
    "    * Redistributions in binary form must reproduce the above copyright notice,\n"..
    "      this list of conditions and the following disclaimer in the documentation\n"..
    "      and/or other materials provided with the distribution.\n"..
    "\n"..
    "THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND\n"..
    "ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n"..
    "WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n"..
    "DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR\n"..
    "ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n"..
    "(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n"..
    "LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON\n"..
    "ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n"..
    "(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"..
    "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"..
    "\]\]--";

function buildPetAndMountDatabase()
    PetAndMountDatabase = {
        WoWVersion = 20403,
        Collections = {
            MiniPets = {
                Normal = {
                    [19450] = true, -- A Jubling's Tiny Home
                    [11023] = true, -- Ancona Chicken
                    [34535] = true, -- Azure Whelpling
                    [32588] = true, -- Banana Charm
                    [10360] = true, -- Black Kingsnake
                    [29958] = true, -- Blue Dragonhawk Hatchling
                    [29901] = true, -- Blue Moth Egg
                    [20371] = true, -- Blue Murloc Egg
                    [29364] = true, -- Brown Rabbit Crate
                    [10361] = true, -- Brown Snake
                    [29960] = true, -- Captured Firefly
                    [23083] = true, -- Captured Flame
                    [8491]  = true, -- Cat Carrier (Black Tabby)
                    [8485]  = true, -- Cat Carrier (Bombay)
                    [8486]  = true, -- Cat Carrier (Cornish Rex)
                    [8487]  = true, -- Cat Carrier (Orange Tabby)
                    [8490]  = true, -- Cat Carrier (Siamese)
                    [8488]  = true, -- Cat Carrier (Silver Tabby)
                    [8489]  = true, -- Cat Carrier (White Kitten)
                    [11110] = true, -- Chicken Egg
                    [35350] = true, -- Chuck's Bucket
                    [34425] = true, -- Clockwork Rocket Bot
                    [10393] = true, -- Cockroach
                    [10392] = true, -- Crimson Snake
                    [10822] = true, -- Dark Whelpling
                    [34493] = true, -- Dragon Kite
                    [13584] = true, -- Diablo Stone
                    [20769] = true, -- Disgusting Oozeling
                    [32616] = true, -- Egbert's Egg
                    [32622] = true, -- Elekk Training Collar
                    [29953] = true, -- Golden Dragonhawk Hatchling
                    [8500]  = true, -- Great Horned Owl
                    [8501]  = true, -- Hawk Owl
                    [23713] = true, -- Hippogryph Hatchling
                    [15996] = true, -- Lifelike Mechanical Toad
                    [11826] = true, -- Lil' Smoky
                    [30360] = true, -- Lurky's Egg
                    [27445] = true, -- Magical Crawdad Box
                    [29363] = true, -- Mana Wyrmling
                    [10398] = true, -- Mechanical Chicken
                    [4401]  = true, -- Mechanical Squirrel Box
                    [31760] = true, -- Miniwing
                    [33993] = true, -- Mojo
                    [33818] = true, -- Muckbreath's Bucket
                    [38628] = true, -- Nether Ray Fry
                    [25535] = true, -- Netherwhelp's Collar
                    [13583] = true, -- Panda Collar
                    [8496]  = true, -- Parrot Cage (Cockatiel)
                    [8492]  = true, -- Parrot Cage (Green Wing Macaw)
                    [8494]  = true, -- Parrot Cage (Hyacinth Macaw)
                    [8495]  = true, -- Parrot Cage (Senegal)
                    [11825] = true, -- Pet Bombling
                    [35504] = true, -- Phoenix Hatchling
                    [23007] = true, -- Piglet's Collar
                    [22114] = true, -- Pink Murloc Egg
                    [10394] = true, -- Prairie Dog Whistle
                    [8497]  = true, -- Rabbit Crate (Snowshoe)
                    [23015] = true, -- Rat Cage
                    [29956] = true, -- Red Dragonhawk Hatchling
                    [29902] = true, -- Red Moth Egg
                    [34492] = true, -- Rocket Chicken
                    [34955] = true, -- Scorched Stone
                    [29957] = true, -- Silver Dragonhawk Hatchling
                    [33154] = true, -- Sinister Squashling
                    [32617] = true, -- Sleepy Willy
                    [12529] = true, -- Smolderweb Carrier
                    [35349] = true, -- Snarly's Bucket
                    [38050] = true, -- Soul-Trader Beacon
                    [11474] = true, -- Sprite Darter Egg
                    [8499]  = true, -- Tiny Crimson Whelpling
                    [8498]  = true, -- Tiny Emerald Whelpling
                    [34478] = true, -- Tiny Spore Bat
                    [33816] = true, -- Toothy's Bucket
                    [31665] = true, -- Toy RC Mortar Tank [[NYA]]
                    [21277] = true, -- Tranquil Mechanical Yeti
                    [11026] = true, -- Tree Frog Box
                    [22235] = true, -- Truesilver Shafted Arrow
                    [23002] = true, -- Turtle Box
                    [29904] = true, -- White Moth Egg
                    [11027] = true, -- Wood Frog Box
                    [12264] = true, -- Worg Carrier
                    [32233] = true, -- Wolpertinger's Tankard
                    [29903] = true, -- Yellow Moth Egg
                    [13582] = true, -- Zergling Leash
                    }, -- Normal
                
                Reagented = { -- Needs an item to summon
                    Snowball = {
                        [21301] = 17202, -- Green Helper Box
                        [21308] = 17202, -- Jingling Bell
                        [21305] = 17202, -- Red Helper Box
                        [21309] = 17202, -- Snowman Kit
                        }, -- Snowball
                    }, -- Reagented
    
                Equipment = { -- Needs to be equipped
                    Head = {
                        [12185] = "HEADSLOT", -- Bloodsail Admiral's Hat
                        [38506] = "HEADSLOT", -- Don Carlos' Famous Hat
                        },
                    }, -- Equipment
        
                Children = { -- Children's week
                    [31880] = true, -- Blood Elf Orphan Whistle
                    [31881] = true, -- Draenei Orphan Whistle
                    [18598] = true, -- Human Orphan Whistle
                    [18597] = true, -- Orcish Orphan Whistle
                    }, -- Children
                    
                Quest = { -- Used in a quest
                    [30803] = 10629, -- Felhound Whistle for Shizz Work
                    [34253] = 11516, -- Sizzling Embers for Blast the Gateway
                    }, -- Quest
            }, -- MiniPets
            
            Mounts = {
                Ground = {
                    Slow = { -- +0% speed
                         Items = {
                            [33189] = 0, -- Rickety Magic Broom
                            [23720] = 0, -- Riding Turtle
                            },
                        }, -- Slow
                    
                    Fast = { -- +60% speed
                         Items = {
                            [29221] = 60, -- Black Hawkstrider
                            [29220] = 60, -- Blue Hawkstrider
                            [8595]  = 60, -- Blue Mechanostrider
                            [13332] = 60, -- Blue Skeletal Horse
                            [2411]  = 60, -- Black Stallion Bridle
--                            [xxxxx] = 60, -- Brewfest Kodo
                            [33976] = 60, -- Brewfest Ram
                            [5656]  = 60, -- Brown Horse Bridle
                            [13333] = 60, -- Brown Skeletal Horse
                            [28481] = 60, -- Brown Elekk
                            [15290] = 60, -- Brown Kodo
                            [5872]  = 60, -- Brown Ram
                            [5655]  = 60, -- Chestnut Mare Bridle
                            [29744] = 60, -- Gray Elekk
                            [15277] = 60, -- Gray Kodo
                            [5864]  = 60, -- Gray Ram
                            [3321]  = 60, -- Green Mechanostrider
                            [1041]  = 60, -- Horn of the Black Wolf
                            [5668]  = 60, -- Horn of the Brown Wolf
                            [5665]  = 60, -- Horn of the Dire Wolf
                            [1134]  = 60, -- Horn of the Gray Wolf
                            [1132]  = 60, -- Horn of the Timber Wolf
                            [14062] = 60, -- Kodo Mount
                            [33183] = 60, -- Old Magic Broom
                            [2414]  = 60, -- Pinto Bridle
                            [29743] = 60, -- Purple Elekk
                            [29222] = 60, -- Purple Hawkstrider
                            [28927] = 60, -- Red Hawkstrider
                            [8563]  = 60, -- Red Mechanostrider
                            [13331] = 60, -- Red Skeletal Horse
                            [21044] = 60, -- Reindeer Reins (TEST)
                            [8627]  = 60, -- Reins of the Night saber
                            [33224] = 60, -- Reins of the Spectral Tiger
                            [8632]  = 60, -- Reins of the Spotted Frostsaber
                            [8631]  = 60, -- Reins of the Striped Frostsaber
                            [8628]  = 60, -- Reins of the Spotted Nightsaber
                            [8629]  = 60, -- Reins of the Striped Nightsaber
                            [13322] = 60, -- Unpainted Mechanostrider
                            [8588]  = 60, -- Whistle of the Emerald Raptor
                            [8591]  = 60, -- Whistle of the Turquoise Raptor
                            [8592]  = 60, -- Whistle of the Violet Raptor
                            [5873]  = 60, -- White Ram
                            },
                        Spells = {
                            DeathKnight = {
--                                [-xxxxx]= 60, --Summon Deathcharger
                                },
                            Paladin = {
                                Alliance = {
                                    [-13819]= 60, --Summon Warhorse (Alliance)
                                    },
                                Horde = {
                                    [-34769]= 60, --Summon Warhorse (Horde)
                                    },
                                },
                            Warlock = {
                                [-5784]= 60, --Summon Felsteed
                                },
                            },
                        }, -- Fast

                    VeryFast = { -- +100% speed
                        Items = {
                            [33809] = 100, -- Amani War Bear
                            [18243] = 100, -- Black Battlestrider
                            [29256] = 100, -- Black Battlestrider
                            [13328] = 100, -- Black Ram
                            [18247] = 100, -- Black War Kodo
                            [29466] = 100, -- Black War Kodo
                            [18244] = 100, -- Black War Ram
                            [29467] = 100, -- Black War Ram
                            [18241] = 100, -- Black War Steed Bridle
                            [29468] = 100, -- Black War Steed Bridle
                            [13335] = 100, -- Deathcharger's Reins
                            [30480] = 100, -- Fiery Warhorse's Reins
                            [13329] = 100, -- Frost Ram
                            [29745] = 100, -- Great Blue Elekk
--                            [xxxxx] = 100, -- Great Brewfest Kodo
                            [18794] = 100, -- Great Brown Kodo
                            [18795] = 100, -- Great Gray Kodo
                            [29746] = 100, -- Great Green Elekk
                            [29747] = 100, -- Great Purple Elekk
                            [18793] = 100, -- Great White Kodo
                            [15292] = 100, -- Green Kodo
                            [13334] = 100, -- Green Skeletal Warhorse
                            [12351] = 100, -- Horn of the Arctic Wolf
                            [18245] = 100, -- Horn of the Black War Wolf
                            [29469] = 100, -- Horn of the Black War Wolf
                            [19029] = 100, -- Horn of the Frostwolf Howler
                            [12330] = 100, -- Horn of the Red Wolf
                            [18796] = 100, -- Horn of the Swift Brown Wolf
                            [18798] = 100, -- Horn of the Swift Gray Wolf
                            [18797] = 100, -- Horn of the Swift Timber Wolf
                            [13327] = 100, -- Icy Blue Mechanostrider Mod A
                            [12354] = 100, -- Palomino Bridle
                            [18791] = 100, -- Purple Skeletal Warhorse
                            [29470] = 100, -- Red Skeletal Warhorse
                            [35906] = 100, -- Reins of the Black War Elekk
                            [18242] = 100, -- Reins of the Black War Tiger
                            [29471] = 100, -- Reins of the Black War Tiger
                            [31829] = 100, -- Reins of the Cobalt Riding Talbuk
                            [31830] = 100, -- Reins of the Cobalt Riding Talbuk
                            [29102] = 100, -- Reins of the Cobalt War Talbuk
                            [29227] = 100, -- Reins of the Cobalt War Talbuk
                            [28915] = 100, -- Reins of the Dark Riding Talbuk
                            [29228] = 100, -- Reins of the Dark War Talbuk
                            [12302] = 100, -- Reins of the Frostsaber
                            [12303] = 100, -- Reins of the Nightsaber
                            [32768] = 100, -- Reins of the Raven Lord
                            [31831] = 100, -- Reins of the Silver Riding Talbuk
                            [31832] = 100, -- Reins of the Silver Riding Talbuk
                            [29104] = 100, -- Reins of the Silver War Talbuk
                            [29229] = 100, -- Reins of the Silver War Talbuk
                            [18766] = 100, -- Reins of the Swift Frostsaber
                            [18767] = 100, -- Reins of the Swift Mistsaber
                            [33225] = 100, -- Reins of the Swift Spectral Tiger
                            [18902] = 100, -- Reins of the Swift Stormsaber
                            [31833] = 100, -- Reins of the Tan Riding Talbuk
                            [31834] = 100, -- Reins of the Tan Riding Talbuk
                            [29105] = 100, -- Reins of the Tan War Talbuk
                            [29230] = 100, -- Reins of the Tan War Talbuk
                            [13086] = 100, -- Reins of the Winterspring Frostsaber
                            [31835] = 100, -- Reins of the White Riding Talbuk
                            [31836] = 100, -- Reins of the White Riding Talbuk
                            [29103] = 100, -- Reins of the White War Talbuk
                            [29231] = 100, -- Reins of the White War Talbuk
                            [19030] = 100, -- Stormpike Battle Charger
                            [18788] = 100, -- Swift Blue Raptor
                            [33977] = 100, -- Swift Brewfest Ram
                            [18786] = 100, -- Swift Brown Ram
                            [18777] = 100, -- Swift Brown Steed
                            [18787] = 100, -- Swift Gray Ram
                            [29223] = 100, -- Swift Green Hawkstrider
                            [18772] = 100, -- Swift Green Mechanostrider
                            [33184] = 100, -- Swift Magic Broom
                            [18789] = 100, -- Swift Olive Raptor
                            [18790] = 100, -- Swift Orange Raptor
                            [18776] = 100, -- Swift Palomino
                            [28936] = 100, -- Swift Pink Hawkstrider
                            [29224] = 100, -- Swift Purple Hawkstrider
                            [19872] = 100, -- Swift Razzashi Raptor
                            [34129] = 100, -- Swift Warstrider
                            [35513] = 100, -- Swift White Hawkstrider
                            [18773] = 100, -- Swift White Mechanostrider
                            [18785] = 100, -- Swift White Ram
                            [18778] = 100, -- Swift White Steed
                            [18774] = 100, -- Swift Yellow Mechanostrider
                            [19902] = 100, -- Swift Zulian Tiger
                            [15293] = 100, -- Teal Kodo
                            [18246] = 100, -- Whistle of the Black War Raptor
                            [29472] = 100, -- Whistle of the Black War Raptor
                            [13317] = 100, -- Whistle of the Ivory Raptor
                            [8586]  = 100, -- Whistle of the Mottled Red Raptor
                            [13326] = 100, -- White Mechanostrider Mod A
                            [12353] = 100, -- White Stallion Bridle

                            TempleOfAhnQiraj = {
                                --The only mounts allowed to be used in Temple of Ahn'Qiraj
                                [21176] = 100, -- Black Qiraji Resonating Crystal
                                [21218] = 100, -- Blue Qiraji Resonating Crystal
                                [21323] = 100, -- Green Qiraji Resonating Crystal
                                [21321] = 100, -- Red Qiraji Resonating Crystal
                                [21324] = 100, -- Yellow Qiraji Resonating Crystal
                                },
                            },
                        Spells = {
                            DeathKnight = {
--                                [-xxxxx]= 100, --Summon Deathcharger
                                },
                            Paladin = {
                                Alliance = {
                                    [-23214]= 100, --Summon Charger (Alliance)
                                    },
                                Horde = {
                                    [-34767]= 100, --Summon Charger (Horde)
                                    },
                                },
                            Warlock = {
                                [-23161]= 100, --Summon Dreadsteed
                                },
                            },
                        }, -- VeryFast
                    }, -- Ground
                Flying = {
                    Fast = { -- +60% speed
                        Items = {
                            [25475] = 60, -- Blue Windrider
                            [25471] = 60, -- Ebon Gryphon
                            [33176] = 60, -- Flying Broom
                            [34060] = 60, -- Flying Machine Control
                            [25470] = 60, -- Golden Gryphon
                            [25476] = 60, -- Green Windrider
                            [25472] = 60, -- Snowy Gryphon
                            [25474] = 60, -- Tawny Windrider
                            [35225] = 60, -- X-51 Nether-Rocket
                            },
                        }, -- Fast
                    
                    VeryFast = { -- +280% speed
                        Items = {
                            [32319] = 280, -- Blue Riding Nether Ray
                            [33999] = 280, -- Cenarion War Hippogryph
                            [32314] = 280, -- Green Riding Nether Ray
                            [32316] = 280, -- Purple Riding Nether Ray
                            [32317] = 280, -- Red Riding Nether Ray
                            [32858] = 280, -- Reins of the Azure Netherwing Drake
                            [32859] = 280, -- Reins of the Cobalt Netherwing Drake
                            [32857] = 280, -- Reins of the Onyx Netherwing Drake
                            [32860] = 280, -- Reins of the Purple Netherwing Drake
                            [32861] = 280, -- Reins of the Veridian Netherwing Drake
                            [32862] = 280, -- Reins of the Violet Netherwing Drake
                            [32318] = 280, -- Silver Riding Nether Ray
                            [25473] = 280, -- Swift Blue Gryphon
                            [33182] = 280, -- Swift Flying Broom
                            [25528] = 280, -- Swift Green Gryphon
                            [25531] = 280, -- Swift Green Windrider
                            [25529] = 280, -- Swift Purple Gryphon
                            [25533] = 280, -- Swift Purple Windrider
                            [25527] = 280, -- Swift Red Gryphon
                            [25477] = 280, -- Swift Red Windrider
                            [25532] = 280, -- Swift Yellow Windrider
                            [34061] = 280, -- Turbo-Charged Flying Machine Control
                            [35226] = 280, -- X-51 Nether-Rocket XTREME
                            },
                        }, -- VeryFast

                    ExtremelyFast = { -- +310% speed
                        Items = {
                            [32458] = 310, -- Ashes of Al'ar
                            [34092] = 310, -- Merciless Nether Drake
                            [35600] = 310, -- Nether Drake Flying Mount (TEST)
                            [35800] = 310, -- Peep the Phoenix
                            [30609] = 310, -- Swift Nether Drake
                            },
                        }, -- ExtremelyFast
                }, -- Flying

                Passenger = {
                    Ground = {
                        VeryFast = {
                            Items = {
                            }, -- Items
                        }, -- VeryFast
                    }, -- Ground
                    Flying = {
                        ExtremelyFast = {
                            Items = {
                            }, -- Items
                        }, -- ExtremelyFast
                    }, -- Flying
                }, -- Passenger
            }, -- Mounts
            
            Spells = {
                Teleport = {
                    Items = {
                        [-8690]  = 6948,  -- Hearthstone
                        [-46149] = 35230, -- Teleport: Shattrath (Darnarian's Scroll of Teleportation)
                        [-39937] = 28585, -- There's No Place Like Home (Ruby Slippers)
                        Engineering = {
                            Goblin = {
                                [-36890] = 30542, -- Area52 Transporter (Dimensional Ripper - Area 52)
                                [-23442] = 18984, -- Everlook Transporter (Dimensional Ripper - Everlook)
                                },
                            Gnomish = {
                                [-23452] = 18986, -- Gnomish Transporter (Ultrasafe Transporter: Gadgetzan)
                                [-30544] = 30544, -- Toshley's Station Transporter (Ultrasafe Transporter: Toshley's Station)
                                },
                            },
                        },
                    Mage = {
                        Alliance = {
                            [-3565]  = true, -- Teleport: Darnassus
                            [-32271] = true, -- Teleport: Exodar
                            [-3562]  = true, -- Teleport: Ironforge
                            [-33690] = true, -- Teleport: Shattrath
                            [-3561]  = true, -- Teleport: Stormwind
                            [-49359] = true, -- Teleport: Theramore
                            },
                        Horde = {
                            [-3567]  = true, -- Teleport: Orgrimmar
                            [-35715] = true, -- Teleport: Shattrath
                            [-32272] = true, -- Teleport: Silvermoon
                            [-49358] = true, -- Teleport: Stonard
                            [-3566]  = true, -- Teleport: Thunder Bluff
                            [-3563]  = true, -- Teleport: Undercity
                            },
                        },
                    Druid = {
                        [-18960] = true, -- Teleport: Moonglade
                        },
                    Shaman = {
                        [-556]   = true, -- Astral Recall
                        },
                    Translocate = {
                        [-25140] = true,
                        [-25143] = true,
                        [-25649] = true,
                        [-25650] = true,
                        [-25652] = true,
                        [-25666] = true,
                        [-26572] = true,
                        [-29128] = true,
                        [-29129] = true,
                        [-30141] = true,
                        [-32568] = true,
                        [-32569] = true,
                        [-32571] = true,
                        [-32572] = true,
                        [-35376] = true,
                        [-35727] = true,
                        [-35730] = true,
                        [-45368] = true,
                        [-45371] = true,
                        },
                    },
                },
            Items = {
                MountEnchant = {
                    [21212] = true, --Fresh Holly
                    [37750] = true, --Fresh Brewfest Hops
                    [21213] = true, --Preserved Holly
                    [37816] = true, --Preserved Brewfest Hops
                    },
                },
        }, -- Collections

        Sets = {},
        
        Shortcuts = {
            ["PetAndMountDatabase.Spells.Mounts.Ground.VeryFast"] = "m,PetAndMountDatabase.Mounts.Ground.VeryFast.Spells",
            ["PetAndMountDatabase.Spells.Mounts.Ground.Fast"] = "m,PetAndMountDatabase.Mounts.Ground.Fast.Spells",
            ["PetAndMountDatabase.Spells.Alliance"] = "m,PetAndMountDatabase.Spells.Teleport.Mage.Alliance,PetAndMountDatabase.Mounts.Ground.Fast.Spells.Paladin.Alliance,PetAndMountDatabase.Mounts.Ground.VeryFast.Spells.Paladin.Alliance",
            ["PetAndMountDatabase.Spells.Horde"] = "m,PetAndMountDatabase.Spells.Teleport.Mage.Horde,PetAndMountDatabase.Mounts.Ground.Fast.Spells.Paladin.Horde,PetAndMountDatabase.Mounts.Ground.VeryFast.Spells.Paladin.Horde",
            ["PetAndMountDatabase.Spells.DeathKnight"] = "m,PetAndMountDatabase.Mounts.Ground.Fast.Spells.DeathKnight,PetAndMountDatabase.Mounts.Ground.VeryFast.Spells.DeathKnight",
            ["PetAndMountDatabase.Spells.Druid"] = "m,PetAndMountDatabase.Spells.Teleport.Druid",
            ["PetAndMountDatabase.Spells.Mage"] = "m,PetAndMountDatabase.Spells.Teleport.Mage",
            ["PetAndMountDatabase.Spells.Paladin"] = "m,PetAndMountDatabase.Mounts.Ground.Fast.Spells.Paladin,PetAndMountDatabase.Mounts.Ground.VeryFast.Spells.Paladin",
            ["PetAndMountDatabase.Spells.Shaman"] = "m,PetAndMountDatabase.Spells.Teleport.Shaman",
            ["PetAndMountDatabase.Spells.Warlock"] = "m,PetAndMountDatabase.Mounts.Ground.Fast.Spells.Warlock,PetAndMountDatabase.Mounts.Ground.VeryFast.Spells.Warlock",
            ["PetAndMountDatabase.Items.Mounts.Ground.Slow"] = "m,PetAndMountDatabase.Mounts.Ground.Slow.Items",
            ["PetAndMountDatabase.Items.Mounts.Ground.Fast"] = "m,PetAndMountDatabase.Mounts.Ground.Fast.Items",
            ["PetAndMountDatabase.Items.Mounts.Ground.VeryFast"] = "m,PetAndMountDatabase.Mounts.Ground.VeryFast.Items,PetAndMountDatabase.Mounts.Passenger.Ground.VeryFast.Items",
            ["PetAndMountDatabase.Items.Mounts.Flying.Fast"] = "m,PetAndMountDatabase.Mounts.Flying.Fast.Items",
            ["PetAndMountDatabase.Items.Mounts.Flying.VeryFast"] = "m,PetAndMountDatabase.Mounts.Flying.VeryFast.Items",
            ["PetAndMountDatabase.Items.Mounts.Flying.ExtremelyFast"] = "m,PetAndMountDatabase.Mounts.Flying.ExtremelyFast.Items,PetAndMountDatabase.Mounts.Passenger.Flying.ExtremelyFast.Items",
            ["PetAndMountDatabase.Items.MiniPets"] = "m,PetAndMountDatabase.MinPets",
            ["PetAndMountDatabase.TempleOfAhnQiraj.Mounts"] = "m,PetAndMountDatabase.Mounts.Ground.VeryFast.Items.TempleOfAhnQiraj",
            ["PetAndMountDatabase.MountEnchant"] = "m,PetAndMountDatabase.Items.MountEnchant",
        };
    };

    function buildString( set )
        local returnString = "";

        for item, value in pairs( set ) do

        end--for
        return returnString;
    end--function buildString( set )
    
    function LoopSet( set, setName )
        local returnString = "";
        local count = 0;

        for itemName, item in pairs( set ) do
            count = count + 1;
            if( type( item ) == "table" ) then
                LoopSet( item, setName .. "." .. itemName );
            else
                if( returnString:len() > 0 ) then
                    returnString = returnString .. ",";
                end--if
                returnString = returnString .. itemName;
                if( type( item ) ~= "boolean" ) then
                    returnString = returnString .. ":" .. item;
                end--if            
            end--if
        end--for
        if( ( returnString:len() > 0 ) or ( count == 0 ) ) then
            print( ("Adding set %s..."):format( setName ) );
            PetAndMountDatabase.Sets[setName] = returnString;
        end--if
    end--LoopSet( set, setName )
    
    function OutputSets( hFile, sets )
        for setName, set in pairs( sets ) do
            hFile:write( ("        [%q] = %q,\n"):format( setName, set ) );
        end--for
    end--OutputSets( hFile, sets )

    LoopSet( PetAndMountDatabase.Collections, "PetAndMountDatabase" );

    local hFile = io.open( "PetAndMountDatabase_sets.lua", "w+" );

    if( hFile == nil ) then
        return;
    end--if

    hFile:write( HEADER );
    hFile:write( "\n\nPetAndMountDatabaseSets = {\n" );
    hFile:write( ("    WoWVersion = %i,\n"):format( PetAndMountDatabase.WoWVersion ) );
    hFile:write( "    Sets = {\n" );
    OutputSets( hFile, PetAndMountDatabase.Sets );
    hFile:write( "\n        -- Shortcuts\n" );
    OutputSets( hFile, PetAndMountDatabase.Shortcuts );
    hFile:write( "    },\n" );
    hFile:write( "};\n" );
    hFile:close();
end--buildList

buildPetAndMountDatabase();
